<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: init/maginit.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_f813120d4be15aaed9e35a3518d2a85e.html">init</a>
  </div>
</div>
<div class="contents">
<h1>maginit.c</h1><a href="maginit_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: maginit.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="init_8h.html">init.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="maginit_8c.html#accaf6541cd8225c7be69bdf5f6ac44d5">00029</a> <span class="keywordtype">int</span> <a class="code" href="init_8h.html#accaf6541cd8225c7be69bdf5f6ac44d5">MagInit</a>(<a class="code" href="structGridData.html">GridData</a> *gdata)
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00032"></a>00032 
<a name="l00033"></a>00033   <span class="keywordtype">int</span> rank,size;
<a name="l00034"></a>00034   ierr = MPI_Comm_size(PETSC_COMM_WORLD,&amp;size);CHKERRQ(ierr);
<a name="l00035"></a>00035   ierr = MPI_Comm_rank(PETSC_COMM_WORLD,&amp;rank);CHKERRQ(ierr);
<a name="l00036"></a>00036 
<a name="l00037"></a>00037   <span class="comment">/* TODO: rely on readkrn to broadcast n_prop -</span>
<a name="l00038"></a>00038 <span class="comment">     we need it as along as M is a shared vector during serial init.</span>
<a name="l00039"></a>00039 <span class="comment">  */</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041   PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;Creating Vec M for %i nodes\n&quot;</span>,gdata-&gt;<a class="code" href="structGridData.html#a170b7b2a45022cc3d4aaee232844e50c">n_vert</a>);
<a name="l00042"></a>00042   PetscSynchronizedPrintf(PETSC_COMM_WORLD,
<a name="l00043"></a>00043     <span class="stringliteral">&quot;&lt;%i&gt;local nodes: %i  n_prop: %i\n&quot;</span>,
<a name="l00044"></a>00044     rank,gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>
<a name="l00045"></a>00045   );
<a name="l00046"></a>00046   PetscSynchronizedFlush(PETSC_COMM_WORLD);
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   ierr = VecCreate(PETSC_COMM_WORLD,&amp;gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);CHKERRQ(ierr);
<a name="l00049"></a>00049   ierr = VecSetSizes(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*gdata-&gt;<a class="code" href="structGridData.html#ae08e5326571671a361ae5d761d6ca672">ln_vert</a>,PETSC_DECIDE);CHKERRQ(ierr);
<a name="l00050"></a>00050   ierr = VecSetFromOptions(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>);CHKERRQ(ierr);
<a name="l00051"></a>00051   ierr = VecSetBlockSize(gdata-&gt;<a class="code" href="structGridData.html#aa8ed194b67f1446b9c299028c1ed0692">M</a>,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);CHKERRQ(ierr);
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="keywordtype">int</span>       *init_mag;
<a name="l00054"></a>00054   PetscReal *init_magparm;
<a name="l00055"></a>00055   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>),&amp;init_mag);CHKERRQ(ierr);
<a name="l00056"></a>00056   ierr = PetscMalloc(gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>*<span class="keyword">sizeof</span>(PetscReal),&amp;init_magparm);CHKERRQ(ierr);
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>;i++){
<a name="l00059"></a>00059     init_mag[i]=3;
<a name="l00060"></a>00060     init_magparm[i]=0.0;
<a name="l00061"></a>00061   }
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   <span class="keywordtype">int</span> nmax = gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>;
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   PetscTruth flg;
<a name="l00066"></a>00066   ierr = PetscOptionsGetIntArray(PETSC_NULL,<span class="stringliteral">&quot;-init_mag&quot;</span>,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)init_mag,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;nmax,&amp;flg);CHKERRQ(ierr);
<a name="l00067"></a>00067   <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00068"></a>00068     init_mag[0]=3;
<a name="l00069"></a>00069     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00070"></a>00070       <span class="stringliteral">&quot;Option -init_mag not found, using default value: %i\n&quot;</span>,
<a name="l00071"></a>00071       init_mag[0]
<a name="l00072"></a>00072     );
<a name="l00073"></a>00073   }
<a name="l00074"></a>00074   <span class="keywordflow">if</span> (nmax&lt;=1) {
<a name="l00075"></a>00075     ierr = PetscOptionsGetReal(PETSC_NULL,<span class="stringliteral">&quot;-init_magparm&quot;</span>,init_magparm,&amp;flg);CHKERRQ(ierr);
<a name="l00076"></a>00076     <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00077"></a>00077       init_magparm[0]=0;
<a name="l00078"></a>00078       PetscPrintf(PETSC_COMM_WORLD,
<a name="l00079"></a>00079         <span class="stringliteral">&quot;Option -init_magparm not found, using default value: %g\n&quot;</span>,
<a name="l00080"></a>00080         init_magparm[0]
<a name="l00081"></a>00081       );
<a name="l00082"></a>00082     }
<a name="l00083"></a>00083 
<a name="l00084"></a>00084     ierr = <a class="code" href="init_8h.html#a8fd02adfde9e3d9ac120c87dee020678">MagSet</a>(-1,init_mag[0],init_magparm[0],gdata);CHKERRQ(ierr);
<a name="l00085"></a>00085   }
<a name="l00086"></a>00086   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (nmax==gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>) {
<a name="l00087"></a>00087     nmax = gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>;
<a name="l00088"></a>00088     ierr = PetscOptionsGetRealArray(PETSC_NULL,<span class="stringliteral">&quot;-init_magparm&quot;</span>,init_magparm,(<a class="code" href="griddata_8h.html#a515706180f960b30595b607f2d734d14" title="Contains all data to control the simulations.">PetscInt</a>*)&amp;nmax,&amp;flg);CHKERRQ(ierr);
<a name="l00089"></a>00089     <span class="keywordflow">if</span> (flg!=PETSC_TRUE) {
<a name="l00090"></a>00090       PetscPrintf(PETSC_COMM_WORLD,
<a name="l00091"></a>00091         <span class="stringliteral">&quot;Option -init_magparm not found, using default value %g for all volumes\n&quot;</span>,
<a name="l00092"></a>00092         init_magparm[0]
<a name="l00093"></a>00093       );
<a name="l00094"></a>00094     }
<a name="l00095"></a>00095     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (nmax!=gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>) {
<a name="l00096"></a>00096       SETERRQ2(PETSC_ERR_ARG_INCOMP,
<a name="l00097"></a>00097         <span class="stringliteral">&quot;Wrong number of values for option -init_magparm! %i != %i\n&quot;</span>,
<a name="l00098"></a>00098         nmax,gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>
<a name="l00099"></a>00099       );
<a name="l00100"></a>00100     }
<a name="l00101"></a>00101     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>;i++){
<a name="l00102"></a>00102       ierr = <a class="code" href="init_8h.html#a8fd02adfde9e3d9ac120c87dee020678">MagSet</a>(i,init_mag[i],init_magparm[i],gdata);CHKERRQ(ierr);
<a name="l00103"></a>00103     }
<a name="l00104"></a>00104   }
<a name="l00105"></a>00105   <span class="keywordflow">else</span> {
<a name="l00106"></a>00106     SETERRQ2(PETSC_ERR_ARG_INCOMP,
<a name="l00107"></a>00107       <span class="stringliteral">&quot;Wrong number of values for option -init_mag! %i != %i\n&quot;</span>,
<a name="l00108"></a>00108       nmax,gdata-&gt;<a class="code" href="structGridData.html#a4c7b7cea771dca3b63a4a37b0666ffc5">n_prop</a>
<a name="l00109"></a>00109     );
<a name="l00110"></a>00110   }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   ierr = PetscFree(init_mag);CHKERRQ(ierr);
<a name="l00113"></a>00113   ierr = PetscFree(init_magparm);CHKERRQ(ierr);
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00116"></a>00116 }
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

